#pragma once

#include <kr2_program_api/api_v1/cbun/xmlrpc/xmlrpc_server.h>
#include "communication/frontend/xmlrpc_server_methods.h"
#include "communication/bridge/proxy/i_tool_controller.h"
#include "communication/bridge/proxy/i_bridge_connection_status_provider.h"
#include "communication/bridge/proxy/i_tool_connection_status_provider.h"
#include "communication/bridge/proxy/i_program_data_provider.h"

namespace spin
{
    class FrontendServer
    {
    public:
        FrontendServer(std::shared_ptr<IToolController> toolController,
                       std::shared_ptr<IBridgeConnectionStatusProvider> bridgeConnectionStatusProvider,
                       std::shared_ptr<IToolConnectionStatusProvider> toolConnectionStatusProvider,
                       std::shared_ptr<IProgramDataProvider> programDataProvider);
        ~FrontendServer() = default;

        void addMethods();
        

    private:
        kr2_xmlrpc::XmlRpcServer krServer_;
        std::shared_ptr<IToolController> toolController_;
        std::shared_ptr<IBridgeConnectionStatusProvider> bridgeConnectionStatusProvider_;
        std::shared_ptr<IToolConnectionStatusProvider> toolConnectionStatusProvider_;
        std::shared_ptr<IProgramDataProvider> programDataProvider_;
    };

} // namespace spin
